<%-- $Id: edit_agent.jsp 4510 2008-09-11 20:03:48Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.JobAgent"
	import="net.sf.basedb.core.JobAgentSettings"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.JOBAGENT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	JobAgent agent = null;
	Integer port = null;

	final int selectedPluginId = Values.getInt(request.getParameter("plugin_id"), -1);

	// Query to retrieve installed plugins
	ItemQuery<PluginDefinition> pluginQuery = PluginDefinition.getQuery();
	pluginQuery.include(Include.ALL);
	pluginQuery.order(Orders.asc(Hql.property("name")));

	if (itemId == 0)
	{
		title = "Create job agent";
		cc.removeObject("item");
		port = Values.getInteger(cc.getPropertyValue("port"), JobAgent.DEFAULT_PORT);
	}
	else
	{
		agent = JobAgent.getById(dc, itemId);
		cc.setObject("item", agent);
		title = "Edit job agent -- " + HTML.encodeTags(agent.getName());
		agent.checkPermission(Permission.WRITE);
		port = agent.getPort();
	}
		
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Job agent" tab
		function validateJobAgent()
		{
			var frm = document.forms['agent'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (Main.trimString(frm.external_id.value) == '')
			{
				alert("You must enter an external ID");
				frm.external_id.focus();
				return false;
			}
			else if (Main.trimString(frm.port.value) != '')
			{
				var port = parseInt(frm.port.value);
				if (port < 1 || port > 65535)
				{
					alert("The port value must be between 1 and 65535");
					frm.port.focus();
					return false;
				}
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['agent'];
			if (TabControl.validateActiveTab('settings'))
			{
				var plugins = Link.getListIds(frm.plugins, 'P');
				for (var i = 0; i < plugins.length; i++)
				{
					var pluginId = plugins[i];
					var settings = getPluginSettings(pluginId);
					if (settings)
					{
						if (!settings.useDefaultJarPath)
						{
							Forms.createHidden(frm, 'jarPath.'+pluginId, settings.jarPath);
						}
						if (!settings.useDefaultMaxMemory)
						{
							Forms.createHidden(frm, 'maxMemory.'+pluginId, settings.maxMemory);
						}
						if (!settings.useDefaultTrusted)
						{
							Forms.createHidden(frm, 'trusted.'+pluginId, settings.trusted);
						}
						Forms.createHidden(frm, 'priorityBoost.'+pluginId, settings.priorityBoost);
					}
				}
				
				frm.allPlugins.value = plugins.join(',');
				frm.removePlugins.value = Link.getActionIds(-1, 'P').join(',');
				frm.submit();
			}
		}
		
		function addPluginsOnClick()
		{
			var plugins = Link.getListIds(document.forms['agent'].plugins, 'P');
			var url = '../plugindefinitions/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addPluginCallback';
			url += '&exclude='+plugins.join(',');
			Main.openPopup(url, 'AddPlugins', 1000, 700);
		}
		function addPluginCallback(pluginId, name)
		{
			var item = Link.getItem('P', pluginId);
			if (!item) item = new Item('P', pluginId, name);
			Link.addItem(document.forms['agent'].plugins, item);
			pluginsOnClick();
		}

		function removeOnClick()
		{
			Link.removeSelected(document.forms['agent'].plugins);
			Main.hide('pluginsettings');
		}
		
		function initPlugins()
		{
			var plugins = document.forms['agent'].plugins;
			<%
			if (pluginQuery != null)
			{
				ItemResultList<PluginDefinition> plugins = pluginQuery.list(dc);
				for (PluginDefinition plugin : plugins)
				{
					// Default settings
					String defaultJarPath = plugin.getJarPath();
					boolean defaultTrusted = plugin.isTrusted();
					Long defaultMaxMemory = plugin.getMaxMemory();

					// Specific settings
					JobAgentSettings settings = agent == null ? null : agent.getSettings(plugin, false);
					String jarPath = null;
					Boolean trusted = null;
					Long maxMemory = null;
					int priorityBoost = 0;
					if (settings != null)
					{
						jarPath = settings.getJarPath();
						trusted = settings.isTrusted();
						maxMemory = settings.getMaxMemory();
						priorityBoost = settings.getPriorityBoost();
						%>
						Link.addNewItem(plugins, new Item('P', <%=plugin.getId()%>, '<%=HTML.javaScriptEncode(plugin.getName())%>'));
						<%
					}
					%>
					new PluginSetting(<%=plugin.getId()%>, '<%=HTML.javaScriptEncode(jarPath)%>', '<%=HTML.javaScriptEncode(defaultJarPath)%>', '<%=trusted == null ? "" : trusted ? "1" : "0"%>', '<%=defaultTrusted ? "1" : "0"%>', '<%=Values.formatBytes(maxMemory)%>', '<%=Values.formatBytes(defaultMaxMemory)%>', '<%=priorityBoost%>');
					<%
				}
			}
			%>
		}
		
		function selectPlugin(pluginId)
		{
			var frm = document.forms['agent'];
			for (var i = 0; i < frm.plugins.length; i++)
			{
				if (frm.plugins[i].item.id == pluginId)
				{
					frm.plugins.selectedIndex = i;
					pluginsOnClick();
					return;
				}
			}
		}
			
		function init()
		{
			<%
			if (agent == null)
			{
				%>
				var frm = document.forms['agent'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initPlugins();
			<%
			if (selectedPluginId != -1)
			{
				%>
				selectPlugin(<%=selectedPluginId%>);
				<%
			}
			%>
		}
		
		var selectedPluginId;
		function pluginsOnClick()
		{
			var frm = document.forms['agent'];
			var pluginId = frm.plugins[frm.plugins.selectedIndex].item.id;
			var settings = getPluginSettings(pluginId);
			if (settings)
			{
				Main.show('pluginsettings');
				selectedPluginId = pluginId;
				// Set JAR path
				frm.useDefaultJarPath.checked = settings.useDefaultJarPath;
				useDefaultJarPathOnClick();
				var defaultJarPath = document.getElementById("defaultJarPath");
				var html = settings.defaultJarPath;
				if (html.length > 50)
				{
					html = '<span title="'+html+'">'+Main.cutString(html, 50)+'</span>';	
				}
				defaultJarPath.innerHTML = html;
				
				// Set max memory
				frm.useDefaultMaxMemory.checked = settings.useDefaultMaxMemory;
				useDefaultMaxMemoryOnClick();
				var defaultMaxMemory = document.getElementById("defaultMaxMemory");
				defaultMaxMemory.innerHTML = settings.defaultMaxMemory;
				
				// Set trusted
				Forms.checkRadio(frm.trusted, settings.trusted);
				var defaultTrusted = document.getElementById("defaultTrusted");
				defaultTrusted.innerHTML = settings.defaultTrusted == '0' ? 'no' : 'yes';

				// Set priority boost
				frm.priorityBoost.value = settings.priorityBoost;
			}
			else
			{
				Main.hide('pluginsettings');
			}
		}
		
		function priorityBoostOnBlur()
		{
			var frm = document.forms['agent'];
			var settings = getPluginSettings(selectedPluginId);
			if (settings)
			{
				var priorityBoost = parseInt(frm.priorityBoost.value);
				if (priorityBoost < 0 || priorityBoost > 10)
				{
					alert('The priority boost must be between 0 and 10');
					frm.priorityBoost.focus();
					return;
				}
				settings.priorityBoost = priorityBoost;
			}
		}
		
		function useDefaultJarPathOnClick()
		{
			var frm = document.forms['agent'];
			var settings = getPluginSettings(selectedPluginId);
			if (settings)
			{
				var useDefault = frm.useDefaultJarPath.checked;
				settings.useDefaultJarPath = useDefault;
				frm.jarPath.disabled = useDefault;
				if (!useDefault) 
				{
					frm.jarPath.focus();
					frm.jarPath.value = settings.jarPath;
				}
			}
		}
		
		function jarPathOnBlur()
		{
			var frm = document.forms['agent'];
			var settings = getPluginSettings(selectedPluginId);
			if (settings)
			{
				settings.jarPath = frm.jarPath.value;
			}
		}
		
		function useDefaultMaxMemoryOnClick()
		{
			var frm = document.forms['agent'];
			var settings = getPluginSettings(selectedPluginId);
			if (settings)
			{
				var useDefault = frm.useDefaultMaxMemory.checked;
				settings.useDefaultMaxMemory = useDefault;
				frm.maxMemory.disabled = useDefault;
				if (!useDefault) 
				{
					frm.maxMemory.focus();
					frm.maxMemory.value = settings.maxMemory;
				}
			}
		}
		
		function maxMemoryOnBlur()
		{
			var frm = document.forms['agent'];
			var settings = getPluginSettings(selectedPluginId);
			if (settings)
			{
				settings.maxMemory = frm.maxMemory.value;
			}
		}
		
		function trustedOnClick()
		{
			var frm = document.forms['agent'];
			var settings = getPluginSettings(selectedPluginId);
			if (settings)
			{
				var selected = Forms.getCheckedRadio(frm.trusted);
				if (selected != null)
				{
					settings.trusted = selected.value;
					settings.useDefaultTrusted = settings.trusted == '';
				}
			}
		}

		
		function getPluginSettings(pluginId)
		{
			return allPluginSettings['P'+pluginId];
		}
		
		var allPluginSettings = new Array();
		function PluginSetting(pluginId, jarPath, defaultJarPath, trusted, defaultTrusted, 
			maxMemory, defaultMaxMemory, priorityBoost)
		{
			this.pluginId = pluginId;
			this.jarPath = jarPath;
			this.defaultJarPath = defaultJarPath == '' ? 'internal' : defaultJarPath;
			this.useDefaultJarPath = (jarPath == '');
			this.trusted = trusted;
			this.defaultTrusted = defaultTrusted;
			this.useDefaultTrusted = trusted != null;
			this.maxMemory = maxMemory;
			this.defaultMaxMemory = defaultMaxMemory == '' ? 'not specified' : defaultMaxMemory;
			this.useDefaultMaxMemory = (maxMemory == '');
			this.priorityBoost = priorityBoost;
			allPluginSettings['P'+pluginId] = this;
		}
		
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="agent" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*280)+"px;"%>" 
			position="bottom"  remember="<%=agent != null%>" active="<%=selectedPluginId == -1 ? null : "plugins" %>">
		<t:tab id="info" title="Job agent" validate="validateJobAgent()" helpid="jobagent.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(agent == null ? Values.getString(cc.getPropertyValue("name"), "New job agent") : agent.getName())%>" 
					size="40" maxlength="<%=JobAgent.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">External Id</td>
				<td><input <%=requiredClazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(agent == null ? cc.getPropertyValue("externalId") : agent.getExternalId())%>" 
					size="40" maxlength="<%=JobAgent.MAX_EXTERNAL_ID_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Server</td>
				<td><input <%=clazz%> type="text" name="server" 
					value="<%=HTML.encodeTags(agent == null ? cc.getPropertyValue("server") : agent.getServer())%>" 
					size="40" maxlength="<%=JobAgent.MAX_SERVER_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Port</td>
				<td><input <%=clazz%> type="text" name="port" 
					value="<%=port == null ?  "" : port.toString() %>" 
					size="12" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)">
					<span class="link" onclick="document.forms['agent'].port.value = '<%=JobAgent.DEFAULT_PORT%>'"
						>Use default (<%=JobAgent.DEFAULT_PORT%>)</span>
					</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(agent == null ? cc.getPropertyValue("description") : agent.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'agent', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="plugins" title="Plugins" helpid="jobagent.plugins">
		
			<table >
			<tr valign="top">
			<td>
				<b>Installed plugins</b><br>
				<select name="plugins" size="14" multiple style="width: 15em;" 
					onclick="pluginsOnClick()">
				</select>
				<input type="hidden" name="removePlugins" value="">
				<input type="hidden" name="allPlugins" value="">
			</td>
			<td>
				<br>
				<table width="150">
				<tr><td><base:button 
					onclick="addPluginsOnClick()" 
					title="Add&nbsp;plugins&hellip;"  
					tooltip="Add plugins to this job agent"
				/></td></tr>
				<tr><td><base:button 
					onclick="removeOnClick()" 
					title="Remove" 
					tooltip="Remove the selected plugins"
				/></td></tr>
				</table>

				<br>
				<div id="pluginsettings" style="display: none;">
				<table border="0" cellspacing="0" class="form">
				<tr>
					<td class="prompt">Jar path</td>
					<td>
						<input type="text" name="jarPath" class="text" size="50" 
							maxlength="<%=JobAgentSettings.MAX_JARPATH_LENGTH%>"
							onblur="jarPathOnBlur()">
					</td>
				</tr>
				<tr>
					<td style="padding-left: 10px;">-use default</td>
					<td>
						<input type="checkbox" name="useDefaultJarPath"
							onclick="useDefaultJarPathOnClick()">
						(<span id="defaultJarPath"></span>)
					</td>
				</tr>
				<tr>
					<td class="prompt">Max memory</td>
					<td>
						<input type="text" name="maxMemory" class="text" size="16" 
							maxlength="16"
							onblur="maxMemoryOnBlur()">
							(Use KB, MB or GB to specify memory)
					</td>
				</tr>
				<tr>
					<td style="padding-left: 10px;">-use default</td>
					<td>
						<input type="checkbox" name="useDefaultMaxMemory"
							onclick="useDefaultMaxMemoryOnClick()">
						(<span id="defaultMaxMemory"></span>)
					</td>
				</tr>
				<tr>
					<td class="prompt">Trusted</td>
					<td>
						<input type="radio" name="trusted" value="" 
							onclick="trustedOnClick()">default (<span id="defaultTrusted"></span>)
						<input type="radio" name="trusted" value="1"
							onclick="trustedOnClick()">yes
						<input type="radio" name="trusted" value="0"
							onclick="trustedOnClick()">no
					</td>
				</tr>
				<tr>
					<td class="prompt">Priority boost</td>
					<td>
						<input type="text" name="priorityBoost" class="text" size="12" 
							maxlength="10" onkeypress="return Numbers.integerOnly(event)"
							onblur="priorityBoostOnBlur()">
					</td>
				</tr>
				</table>
				</div>
			</td>
			</tr>
			</table>
			
			
		</t:tab>
		
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
