<%-- $Id: edit_news.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.News"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.util.Values"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.NEWS;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	News news = null;
	Date startDate = null;
	Date newsDate = null;

	if (itemId == 0)
	{
		title = "Create news";
		cc.removeObject("item");
		startDate = (Date)cc.getPropertyObject("startDate");
		newsDate = (Date)cc.getPropertyObject("newsDate");
	}
	else
	{
		news = News.getById(dc, itemId);
		cc.setObject("item", news);
		title = "Edit news -- " + HTML.encodeTags(news.getName());
		startDate = news.getStartDate();
		newsDate = news.getNewsDate();
	}
	if (news != null && !news.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "News" tab
		function validateNews()
		{
			var dateFormat = '<%=jsDateFormat%>';
			var frm = document.forms['news'];
			if (Main.trimString(frm.title.value) == '')
			{
				alert("You must enter a title");
				frm.title.focus();
				return false;
			}
			else if (!Dates.isDate(frm.start_date.value, dateFormat))
			{
				alert("'"+frm.start_date.value+"' is not a valid value for start date");
				frm.start_date.focus();
				return false;
			}
			else if (!Dates.isDate(frm.news_date.value, dateFormat))
			{
				alert("'"+frm.news_date.value+"' is not a valid value for news date");
				frm.start_date.focus();
				return false;
			}
			else if (frm.end_date.value != '' && !Dates.isDate(frm.end_date.value, dateFormat))
			{
				alert("'"+frm.end_date.value+"' is not a valid value for end date");
				frm.start_date.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['news'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (news == null)
			{
				%>
				var frm = document.forms['news'];
				frm.title.focus();
				frm.title.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="news" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*280)+"px;"%>" 
			position="bottom"  remember="<%=news != null%>">
		<t:tab id="info" title="News" validate="validateNews()" helpid="news.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Title</td>
				<td colspan="2"><input <%=requiredClazz%> type="text" name="title" 
					value="<%=HTML.encodeTags(news == null ? Values.getString(cc.getPropertyValue("name"), "New news") : news.getName())%>" 
					size="40" maxlength="<%=News.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Start date</td>
				<td>
					<input <%=requiredClazz%> type="text" name="start_date" 
					value="<%=HTML.encodeTags(dateFormatter.format(startDate == null ? new Date() : startDate))%>"
					size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
				</td>
				<td>
					<base:button 
						onclick="<%="Dates.selectDate('Start date', 'news', 'start_date', null, '"+jsDateFormat+"')"%>" 
						image="calendar.png"
						title="Calendar&hellip;" 
						tooltip="Select a date from a calendar" 
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">News date</td>
				<td>
					<input <%=requiredClazz%> type="text" name="news_date" 
						value="<%=HTML.encodeTags(dateFormatter.format(newsDate == null ? new Date() : newsDate))%>" 
						size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
				</td>
				<td>
					<base:button 
						onclick="<%="Dates.selectDate('News date', 'news', 'news_date', null, '"+jsDateFormat+"')"%>" 
						image="calendar.png"
						title="Calendar&hellip;" 
						tooltip="Select a date from a calendar" 
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">End date</td>
				<td>
					<input <%=clazz%> type="text" name="end_date" 
					value="<%=dateFormatter.format(news == null ? 
							(Date)cc.getPropertyObject("endDate") : news.getEndDate())%>" 
					size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>"><br>
				</td>
				<td>
					<base:button 
						onclick="<%="Dates.selectDate('End date', 'news', 'end_date', null, '"+jsDateFormat+"')"%>" 
						image="calendar.png"
						title="Calendar&hellip;" 
						tooltip="Select a date from a calendar" 
					/>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td  colspan="2" nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(news == null ? cc.getPropertyValue("description") : news.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'news', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
