<%-- $Id: submit_share.jsp 5136 2009-10-15 06:33:07Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Configure the order and visibility of columns in a table of items.
	This page will use the TableColumn.getTableColumns(item) to retreive the
	list of all available columns for that item type and
	getSession().getSetting(item+".columns") to retreive a comma-separated
	list of the current order of visible columns.

	@param item The type of items in the table
	@param cmd
	  - Save: To save the settings
	  - otherwise: A configuration dialouge is displayed
	@param columns Only used if cmd=Save. Contains a comma-separated list
		of column ID:s which is saved to a user-client setting.

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.Arrays"
	import="java.util.Set"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";

String forward = null;
String message = null;
final DbControl dc = sc.newDbControl();
try
{
	if ("Save".equals(cmd))
	{
		ItemContext cc = sc.getCurrentContext(itemType, subContext);
		MultiPermissions mp = (MultiPermissions)cc.getObject("MultiPermissions");
		boolean recursive = Values.getBoolean(request.getParameter("recursive"));
		
		String[] modifiedUsers = Values.getString(request.getParameter("modifiedUsers")).split(",");
		for (int i = 0; i < modifiedUsers.length; ++i)
		{
			int userId = Values.getInt(modifiedUsers[i], -1);
			if (userId != -1) 
			{
				Set<Permission> permissions = PermissionUtil.getPermissions(Values.getInt(request.getParameter("U"+userId), 0));
				mp.setPermissions(User.getById(dc, userId), permissions);
			}
		}
		
		String[] modifiedGroups = Values.getString(request.getParameter("modifiedGroups")).split(",");
		for (int i = 0; i < modifiedGroups.length; ++i)
		{
			int groupId = Values.getInt(modifiedGroups[i], -1);
			if (groupId != -1) 
			{
				Set<Permission> permissions = PermissionUtil.getPermissions(Values.getInt(request.getParameter("G"+groupId), 0));
				mp.setPermissions(Group.getById(dc, groupId), permissions);
			}
		}
	
		String[] modifiedProjects = Values.getString(request.getParameter("modifiedProjects")).split(",");
		for (int i = 0; i < modifiedProjects.length; ++i)
		{
			int projectId = Values.getInt(modifiedProjects[i], -1);
			if (projectId != -1) 
			{
				Set<Permission> permissions = PermissionUtil.getPermissions(Values.getInt(request.getParameter("P"+projectId), 0));
				mp.setPermissions(Project.getById(dc, projectId), permissions);
			}
		}
		mp.updateKeys(dc, recursive);
		sc.reloadPermissions();
		dc.commit();
		cc.removeObject("MultiPermissions");
		message = "Items shared";
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>
