<%-- $Id: set_active.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
%>
<%@ taglib
	prefix="base" uri="/WEB-INF/base.tld"
%>
<%
SessionControl sc = Base.getExistingSessionControl(pageContext, true);
String ID = sc.getId();
int projectId = Values.getInt(request.getParameter("project_id"), 0);

String title = "";
String message = "";

DbControl dc = sc.newDbControl();
try
{
	Project p = null;
	ItemContext allItems = sc.getCurrentContext(Item.PROJECT, "items");
	allItems.getInclude().add(Include.MINE);
	if (projectId != 0) 
	{
		p = Project.getById(dc, projectId);
		allItems.getInclude().add(Include.OTHERS);
	}
	sc.setActiveProject(p);
	sc.setUserClientSetting("projects.lastactive", projectId == 0 ? null : Integer.toString(projectId));
	sc.setSessionSetting("menu.standard.html", null);
	if (p == null)
	{
		title = "All projects deactivated";
		message = "No active project.";
	}
	else
	{
		title = "Project activated";
		message = "The project <b><i>"+HTML.encodeTags(p.getName())+"</i></b> "+
			"is now the active project.";
	}
}
finally
{
	if (dc != null) dc.close();
}
%>
<base:page type="popup" title="<%=title%>">
<base:head>
<script language="JavaScript">
function reloadAndClose()
{
	window.opener.location.reload();
	window.close();
}
</script>
</base:head>
<base:body onload="reloadAndClose()">
	<base:note type="info" title="<%=title%>">
		<%=message%>
	</base:note>
	<p>
	<table align="center">
	<tr>
		<td><base:button onclick="window.close();" title="Ok" /></td>
	</tr>
	</table>
</base:body>
</base:page>

