<%-- $Id: view_job.jsp 5073 2009-08-21 10:15:11Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Gregory Vincic
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.JobAgent"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Path"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ChangeHistory"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.ParameterInfo"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.signal.SignalTransporter"
	import="net.sf.basedb.core.signal.Signal"
	import="net.sf.basedb.plugins.util.Parameters"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
	import="java.util.Collections"
	import="java.util.Collection"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!
	private static final Item itemType = Item.JOB;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);

	private String getItemName(BasicItem item)
	{
		String itemName = "";
		if (item instanceof File)
		{
			itemName = ((File)item).getPath().toString();
		}
		else if (item instanceof Nameable)
		{
			itemName = ((Nameable)item).getName();
		}
		else
		{
			itemName = item.toString();
		}
		return itemName;
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Job job = Job.getById(dc, itemId);
	String title = "View job -- " + HTML.encodeTags(job.getName());
	
	final boolean writePermission = job.hasPermission(Permission.WRITE);
	final boolean deletePermission = job.hasPermission(Permission.DELETE);
	final boolean isRemoved = job.isRemoved();
	final boolean isUsed = isRemoved && job.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	
	boolean readCurrentConfig = true;
	PluginConfiguration currentConfig = null;
	try
	{
		currentConfig = job.getPluginConfiguration();
	}
	catch (PermissionDeniedException ex)
	{
		readCurrentConfig = false;
	}
	boolean readAgent = true;
	JobAgent agent = null;
	try
	{
		agent = job.getJobAgent();
	}
	catch (PermissionDeniedException ex)
	{
		readAgent = false;
	}

	int parameterVersion = job.getParameterVersion();
	int latestParameterVersion = currentConfig == null ? parameterVersion : currentConfig.getParameterVersion();

	final Job.Status status = job.getStatus();
	final boolean autoUpdate = status == Job.Status.WAITING || 
		status == Job.Status.PREPARED || status == Job.Status.EXECUTING || status == Job.Status.ABORTING;
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Set<String> jobParameters = job.getParameterNames();
	File logFile = null;
	if (!autoUpdate && jobParameters != null && jobParameters.contains(Parameters.LOGFILE_PARAMETER))
	{
		try
		{
			Object temp = job.getParameterValue(Parameters.LOGFILE_PARAMETER);
			if (temp instanceof File)
			{
				logFile = (File)temp;
			}
			else if (temp instanceof String)
			{
				logFile = File.getByPath(dc, new Path((String)temp, Path.Type.FILE), false);
			}
		}
		catch (Throwable t)
		{}
	}
	
	// Check if the plug-in supports the "Abort" signal
	boolean supportsAbort = status == Job.Status.WAITING && writePermission;
	if (status == Job.Status.EXECUTING && writePermission)
	{
		try
		{
			SignalTransporter signalTransporter = job.getSignalTransporter();
			Collection<Signal> supportedSignals = signalTransporter != null ? 
				signalTransporter.getSupportedSignals() : null;
			supportsAbort = signalTransporter != null && 
				(supportedSignals == null || supportedSignals.contains(Signal.ABORT));
		}
		catch (Exception ex)
		{}
	}
	%>
	<base:page type="popup" title="<%=title%>">	
	<base:head scripts="tabcontrol.js,table.js" styles="tabcontrol.css,progressbar.css,table.css">
	<script language="JavaScript">
	function autoUpdate()
	{
		var autoUpdate = <%=autoUpdate ? "true" : "false"%>;
		if (autoUpdate)
		{
			setTimeout('location.reload()', 10000);
		}
	}
	function abortJob()
	{
		if (confirm('Are you sure? This action may not be undone'))
		{
			location.href = 'index.jsp?ID=<%=ID%>&cmd=AbortJob&item_id=<%=itemId%>';
		}
	}
	function restartJob(clearDryRun)
	{
		var parameterVersion = <%=parameterVersion%>;
		var latestVersion = <%=latestParameterVersion%>;
		var useLatestConfiguration = 0;
		if (parameterVersion != latestVersion)
		{
			var msg = 'The configuration parameters for the plugin has changed since\n';
			msg += 'the job was added to the job queue. Do you want to use the new\n';
			msg += 'configuration parameters?\n\n';
			msg += 'Ok / Yes = Use the new parameters (version = '+latestVersion + ')\n';
			msg += 'Cancel / No = Use the current parameters (version = ' + parameterVersion + ')';
			if (confirm(msg)) useLatestConfiguration = 1;
		}
		var url = 'index.jsp?ID=<%=ID%>&cmd=RestartJob&item_id=<%=itemId%>';
		url += '&useLatestConfiguration='+useLatestConfiguration;
		if (clearDryRun) url += '&clearDryRun=' + clearDryRun;
		location.href = url;
	}
	function reconfigureJob()
	{
		location.href = '../../common/plugin/index.jsp?ID=<%=ID%>&cmd=ConfigureJob&job_id=<%=itemId%>';
	}
	
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			location.href = getRoot() + 'common/close_popup.jsp?ID=<%=ID%>&refresh_opener=1&wait=0';
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
	</script>
	</base:head>
	<base:body onload="autoUpdate()">
		<h3 class="docked"><%=title%> <base:help tabcontrol="main" /></h3>
		<t:tabcontrol id="main" active="<%=tab%>" position="bottom" contentstyle="<%="height: "+(int)(scale*350)+"px;"%>">
		<t:tab id="properties" title="Properties" helpid="job.view.properties">

			<%
			if (job.isRemoved())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(job.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(job.getDescription())%></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Priority</td>
				<td>
					<%=job.getPriority()%> (1 = highest, 10 = lowest)
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Status</td>
				<td <%=job.getStatus() == Job.Status.ERROR ? "class=\"error\" style=\"text-align: left;\"" : "" %>>
					<%=job.getStatus()%><%=job.isDryRun() ? " (dry-run)" : "" %>: <%=HTML.niceFormat(job.getStatusMessage())%>
				</td>
			</tr>
			<tr valign="middle">
				<td class="prompt">Percent complete</td>
				<td>
					<table border=0 cellspacing=0 cellpadding=0>
					<tr>
					<td width="100" valign="middle">
						<table width="100" class="progressbar" border=0 cellspacing=0 cellpadding=0>
						<tr>
							<%
							int percent = job.getPercentComplete();
							if (percent > 0) 
							{
								%>
								<td width="<%=percent%>%" class="done">&nbsp;</td>
								<% 
							}
							if (percent < 100) 
							{ 
								%>
								<td width="<%=100-percent%>%" class="remain">&nbsp;</td>
								<%
							}
							%>
						</tr>
						</table>
					</td>
					<td valign="middle">&nbsp;<%=percent%>%</td>
					<%
					if (logFile != null)
					{
						%>
						<td valign="middle" style="padding-left: 10px;"><base:button image="view.gif" 
								title="View log&hellip;"
								onclick="<%="Main.viewFile('" + ID + "', " + logFile.getId() + ")"%>"
								tooltip="View the log file with detailed information about this job"
								/></td>
							<%
						}
						%>
					</tr>
					</table>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Created</td>
				<td>
					<%=dateTimeFormatter.format(job.getCreated())%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Started</td>
				<td>
					<%=dateTimeFormatter.format(job.getStarted())%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Ended</td>
				<td>
					<%=dateTimeFormatter.format(job.getEnded())%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Running time</td>
				<td>
					<%
					Date started = job.getStarted();
					if (started != null)
					{
						Date ended = job.getEnded();
						if (ended == null) ended = new Date();
						long runningTime = ended.getTime() - started.getTime();
						%>
						<%=Values.formatTime(runningTime / 1000)%>
						<%
					}
					%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Server</td>
				<td>
					<%=HTML.encodeTags(job.getServer())%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Job agent</td>
				<td><%=Base.getEncodedName(agent, !readAgent)%></td>
			</tr>
			<tr valign="top">
				<td class="prompt">User</td>
				<td>
					<base:propertyvalue item="<%=job%>" property="owner.name" />
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Experiment</td>
				<td>
					<base:propertyvalue item="<%=job%>" property="experiment.name" />
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Plugin</td>
				<td>
					<base:propertyvalue item="<%=job%>" property="pluginDefinition.name" /> 
					<%=job.getPluginVersion() == null ?
						"" : "(version " + HTML.encodeTags(job.getPluginVersion()) + ")"%>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Configuration</td>
				<td>
					<base:propertyvalue item="<%=job%>" property="pluginConfiguration.name" />
				</td>
			</tr>
			</table>
			</t:tab>
			<%
			if (job.getStackTrace() != null)
			{
				%>
				<t:tab id="stacktrace" title="Stack trace" helpid="job.view.stacktrace">
					<div style="font-family: monospace">
					<%=HTML.niceFormat(job.getStackTrace())%>
					</div>
				</t:tab>
				<%
			}
			%>
	
			<t:tab id="parameters" title="Parameters" helpid="job.view.parameters">
				<h4>Job parameters</h4>
				<table class="form" cellspacing=0>
				<%
				List<String> names = new java.util.ArrayList<String>(jobParameters);
				Collections.sort(names);
				for (String name : names)
				{
					StringBuilder sb = new StringBuilder();
					String displayValue = "";
					String description = "";
					try
					{
						ParameterInfo pi = job.getParameterInfo(name);
						if (pi.getLabel() != null) name = HTML.encodeTags(pi.getLabel());
						description = HTML.encodeTags(pi.getDescription());
						List<?> values = pi.getValues();
						int i = 0;
						for (Object value : values)
						{
							if (value != null)
							{
								if (i > 0) sb.append(", ");
								i++;
								if (value instanceof BasicItem)
								{
									sb.append(HTML.encodeTags(getItemName((BasicItem)value)));
								}
								else if (value instanceof Date)
								{
									sb.append(dateFormatter.format((Date)value));
								}
								else
								{
									sb.append(HTML.encodeTags(value.toString()));
								}
							}
						}
						displayValue = sb.toString();
					}
					catch (Throwable ex)
					{
						displayValue = "<i>ERROR: "+ex.getMessage()+"</i>";
					}
					%>
					<tr>
						<td class="prompt"><span title="<%=description%>"><%=name%></span></td>
						<td>
							<%=displayValue%>
						</td>
					</tr>
					<%
				}
				%>
				</table>

				<%
				if (!readCurrentConfig)
				{
					%>
					<h4>Plugin configuration parameters</h4>
					<i>- denied -</i>
					<%
				}
				else if (currentConfig != null)
				{
					%>
					<h4>Plugin configuration parameters</h4>
					<table class="form" cellspacing=0>
					<tr>
						<td class="prompt"><span 
							title="The version of the parmeters used for this job, current version in paranthesis">Parameter version</span></td>
						<td><%=parameterVersion%> (<%=latestParameterVersion %>)</td>
					</tr>
					<%
					names = new java.util.ArrayList<String>(currentConfig.getParameterNames(parameterVersion));
					Collections.sort(names);
					for (String name : names)
					{
						StringBuilder sb = new StringBuilder();
						String displayValue = "";
						String description = "";
						try
						{
							ParameterInfo pi = currentConfig.getParameterInfo(name, parameterVersion);
							if (pi.getLabel() != null) name = HTML.encodeTags(pi.getLabel());
							description = HTML.encodeTags(pi.getDescription());
							List<?> values = pi.getValues();
							int i = 0;
							for (Object value : values)
							{
								if (value != null)
								{
									if (i > 0) sb.append(", ");
									i++;
									if (value instanceof BasicItem)
									{
										sb.append(HTML.encodeTags(getItemName((BasicItem)value)));
									}
									else if (value instanceof Date)
									{
										sb.append(dateFormatter.format((Date)value));
									}
									else
									{
										sb.append(HTML.encodeTags(value.toString()));
									}
								}
							}
							displayValue = sb.toString();
						}
						catch (Throwable ex)
						{
							displayValue = "<i>ERROR: "+ex.getMessage()+"</i>";
						}
						%>
						<tr>
							<td class="prompt"><span title="<%=description%>"><%=name%></span></td>
							<td>
								<%=displayValue%>
							</td>
						</tr>
						<%
					}
					%>
					</table>
					<%
				}
				%>
				
			</t:tab>
			
			<t:tab id="changes" title="Changed items"
				tooltip="Display a log of all modifications made by this job"
				visible="<%=!autoUpdate && ChangeHistoryUtil.showChangeHistoryTab(sc) %>">
				<%
				ItemQuery<ChangeHistory> query = ChangeHistory.getChangesBy(job);
				query.order(Orders.asc(Hql.property("id")));
				ItemResultIterator<ChangeHistory> changes = query.iterate(dc);
				int numChanges = 0;
				%>
				<tbl:table id="history" clazz="itemlist" columns="all">
					<tbl:columndef id="changeType" title="Change type" />
					<tbl:columndef id="item" title="Item" />
					<tbl:columndef id="info" title="Info" />
					
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						while (changes.hasNext())
						{
							numChanges++;
							ChangeHistory change = changes.next();
							%>
							<tbl:row>
								<tbl:cell column="changeType"><%=change.getChangeType()%> <%=change.getItemType()%></tbl:cell>
								<tbl:cell column="item"><%=ChangeHistoryUtil.getItem(dc, change, false, false)%></tbl:cell>
								<tbl:cell column="info"><%=HTML.encodeTags(change.getChangeInfo())%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
					<%
					if (numChanges == 0)
					{
						%>
						<tbl:panel>
						No log entries found for this job. NOTE! This job may have made 
						other changes that are not recorded by the logging mechanism.
						</tbl:panel>
						<%
					}
					%>
				</tbl:table>
				
			</t:tab>
			
			</t:tabcontrol>
	
		<base:buttongroup align="center">
			<%
			if (autoUpdate)
			{
				%>
				<base:button onclick="location.reload()" title="Refresh" image="refresh.gif" />
				<%
			}
			%>
			<%
			if (supportsAbort)
			{
				%>
				<base:button onclick="abortJob()" title="Abort&hellip;" image="abort.png" />
				<%
			}
			%>
			<%
			if (job.getStatus() == Job.Status.ERROR && job.getJobType() == Job.Type.RUN_PLUGIN)
			{
				%>
				<base:button onclick="restartJob(0)" title="Restart job" 
					image="refresh.gif" 
					tooltip="Try to run this job again with the same parameters"
				/>
				<base:button onclick="reconfigureJob()" title="Re-configure job"
					image="runplugin.gif"
					tooltip="Change the parameters for this job and try again"
					visible="<%=job.hasContext()%>"
				/>
				<%
			}
			if (job.getStatus() == Job.Status.DONE && job.isDryRun())
			{
				%>
				<base:button onclick="restartJob(1)" title="Really run" 
					image="refresh.gif" 
					tooltip="Run this dry-run job for real"
				/>
				<%
			}
			%>
			<base:button onclick="window.close()" title="Close" />
			
		</base:buttongroup>
		<center>
		<%
		if (autoUpdate)
		{
			%>
			<i>(This page will automatically refresh itself every 10 seconds)</i>
			<%
		}
		%></center>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
