<%-- $Id: edit_reporterlist.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ReporterList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.REPORTERLIST;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	String name = null;
	ReporterList reporterList = null;
	boolean addReporters = false;
	boolean mergeReporterLists = false;
	int numSelectedLists = cc.getSelected().size();
	String formId = request.getParameter("formId");
	String fromContext = Values.getString(request.getParameter("fromContext"), "REPORTER");
	String subContext = request.getParameter("subContext");

	if (itemId == 0)
	{
		title = "Create reporter list";
		cc.removeObject("item");
		addReporters = Values.getBoolean(request.getParameter("addReporters"));
		mergeReporterLists = !addReporters && numSelectedLists > 0;
		name = request.getParameter("name");
		if (name == null) name = Values.getString(cc.getPropertyValue("name"), "New reporter list");
	}
	else
	{
		reporterList = ReporterList.getById(dc, itemId);
		name = reporterList.getName();
		cc.setObject("item", reporterList);
		title = "Edit reporter list -- " + HTML.encodeTags(reporterList.getName());
	}
	if (reporterList != null) reporterList.checkPermission(Permission.WRITE);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Reporter list" tab
		function validateReporterList()
		{
			var frm = document.forms['reporterList'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (frm.minCount)
			{
				var checked = Forms.getCheckedRadio(frm.create);
				if (checked.value == 'count')
				{
					if (!Numbers.isInteger(frm.minCount.value))
					{
						alert('You must specify the number of reporter lists');
						frm.count.focus();
						return false;
					}
					else
					{
						var minCount = parseInt(frm.minCount.value);
						if (minCount < 1 || minCount > <%=numSelectedLists%>)
						{
							alert('You must specify between 1 and <%=numSelectedLists%>');
							frm.count.focus();
							return false;
						}
					}
				}
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['reporterList'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (frm.which) Forms.createHidden(frm, 'items', getSelectedItems().join(','));
				frm.submit();
			}
		}
		
		function init()
		{
			var frm = document.forms['reporterList'];
			<%
			if (reporterList == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			if (frm.which && getSelectedItems().length == 0)
			{
				frm.which[0].disabled = true;
				var aSelected = document.getElementById('which.selected');
				aSelected.href = 'javascript:void(0)';
				aSelected.disabled = true;
				Main.addClass(aSelected, 'disabled');
			}
		}
		// Get the ID:s of all selected reorters
		var selectedItems = new Array();
		var hasCheckSelectedItems = false;
		function getSelectedItems()
		{
			<%
			if (formId != null)
			{
				%>
				if (!hasCheckSelectedItems)
				{
					selectedItems = window.opener.Table.getSelected('<%=formId%>');
					hasCheckedSelectedItems = true;
				}
				<%
			}
			%>
			return selectedItems;
		}
		function checkRadio(radio, name)
		{
			Forms.checkRadio(radio, name);
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="reporterList" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="fromContext" value="<%=fromContext%>">
		<%
		if (subContext != null)
		{
			%>
			<input type="hidden" name="subContext" value="<%=subContext%>">
			<%
		}
		%>
		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*260)+"px;"%>" 
			position="bottom" remember="<%=reporterList != null%>">
		<t:tab id="info" title="Reporter list" 
			validate="validateReporterList()" helpid="reporterlist.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(name)%>" 
					size="40" maxlength="<%=ReporterList.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">External ID</td>
				<td><input <%=clazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(reporterList == null ? Values.getString(cc.getPropertyValue("externalId")) : reporterList.getExternalId())%>" 
					size="40" maxlength="<%=ReporterList.MAX_EXTERNAL_ID_LENGTH%>"></td>
			</tr>
			<%
			if (addReporters)
			{
				%>
				<tr valign="top">
					<td class="prompt">Which reporters?</td>
					<td>
						<input type="radio" name="which" value="selected"><a 
							id="which.selected"
							href="javascript:checkRadio(document.forms['reporterList'].which, 'selected');"
							>Selected items</a><br>
						<input type="radio" name="which" value="page"><a 
							href="javascript:checkRadio(document.forms['reporterList'].which, 'page');"
							>Current page</a><br>
						<input type="radio" name="which" value="all" checked><a 
							href="javascript:checkRadio(document.forms['reporterList'].which, 'all');"
							>All pages</a><br>
					</td>
				</tr>
				<%
			}
			else if (mergeReporterLists)
			{
				%>
				<tr valign="top">
					<td class="prompt">Add reporters?</td>
					<td>
						<input type="radio" name="create" value=""><a
							href="javascript:checkRadio(document.forms['reporterList'].create, '');"
							title="The new reporter list will be empty"
							>No</a><br>
						<input type="radio" name="create" value="union" checked><a
							href="javascript:checkRadio(document.forms['reporterList'].create, 'union');"
							title="The new reporter list contains all reporters from the selected lists"
							>Union of selected lists</a> <base:icon image="set_operations/union_small.png" /><br>
						<input type="radio" name="create" value="intersection"><a
							href="javascript:checkRadio(document.forms['reporterList'].create, 'intersection');"
							title="The new reporter lists contains only reporters that are present in ALL selected lists"
							>Intersection of selected lists</a> <base:icon image="set_operations/intersection_small.png" /><br>
						<input type="radio" name="create" value="count"><a
							href="javascript:checkRadio(document.forms['reporterList'].create, 'count');"
							title="The new reporter lists contains only reporters that are present in some of selected lists"
							>Present in at least</a>
							<input type="text" class="text" name="minCount" size="2" maxlength="2"
								value="1"
								onkeypress="return Numbers.integerOnly(event)"
								onfocus="checkRadio(document.forms['reporterList'].create, 'count');">
							of the selected lists (1-<%=numSelectedLists%>).
							<br>
						
					</td>
				</tr>
				<%
			}
			%>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(reporterList == null ? cc.getPropertyValue("description") : reporterList.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'reporterList', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
